| Flutter Impeller |

Public Member Functions | List of all members
impeller::PlaygroundTest Class Reference

`#include <playground_test.h>`

Inheritance diagram for impeller::PlaygroundTest:

## Public Member Functions
| PlaygroundTest ()
virtual | ~PlaygroundTest ()
void | SetUp () override
void | TearDown () override
PlaygroundBackend | GetBackend () const
std::unique_ptr< fml::Mapping > | OpenAssetAsMapping (std::string asset_name) const override
RuntimeStage::Map | OpenAssetAsRuntimeStage (const char *asset_name) const
std::string | GetWindowTitle () const override
Public Member Functions inherited from impeller::Playground
| Playground (PlaygroundSwitches switches)
virtual | ~Playground ()
void | SetupContext (PlaygroundBackend backend, const PlaygroundSwitches &switches)
void | SetupWindow ()
void | TeardownWindow ()
bool | IsPlaygroundEnabled () const
Point | GetCursorPosition () const
ISize | GetWindowSize () const
Point | GetContentScale () const
Scalar | GetSecondsElapsed () const
| Get the amount of time elapsed from the start of the playground's execution. More...
std::shared_ptr< Context > | GetContext () const
std::shared_ptr< Context > | MakeContext () const
bool | OpenPlaygroundHere (const Renderer::RenderCallback &render_callback)
bool | OpenPlaygroundHere (SinglePassCallback pass_callback)
std::shared_ptr< Texture > | CreateTextureForFixture (const char *fixture_name, bool enable_mipmapping=false) const
std::shared_ptr< Texture > | CreateTextureCubeForFixture (std::array< const char *, 6 > fixture_names) const
fml::Status | SetCapabilities (const std::shared_ptr< Capabilities > &capabilities)
bool | WillRenderSomething () const

## Additional Inherited Members
Public Types inherited from impeller::Playground
using | SinglePassCallback = std::function< bool(RenderPass &pass)>
Static Public Member Functions inherited from impeller::Playground
static bool | ShouldOpenNewPlaygrounds ()
static std::shared_ptr< CompressedImage > | LoadFixtureImageCompressed (std::shared_ptr< fml::Mapping > mapping)
static std::optional< DecompressedImage > | DecodeImageRGBA (const std::shared_ptr< CompressedImage > &compressed)
static std::shared_ptr< Texture > | CreateTextureForMapping (const std::shared_ptr< Context > &context, std::shared_ptr< fml::Mapping > mapping, bool enable_mipmapping=false)
static bool | SupportsBackend (PlaygroundBackend backend)
Protected Member Functions inherited from impeller::Playground
void | SetWindowSize (ISize size)
Protected Attributes inherited from impeller::Playground
const PlaygroundSwitches | switches_

## Detailed Description

Definition at line 21 of file playground_test.h.

## Constructor & Destructor Documentation

## ◆ PlaygroundTest()

impeller::PlaygroundTest::PlaygroundTest | ( |  | ) |

Definition at line 13 of file playground_test.cc.

14 : Playground(PlaygroundSwitches{flutter::testing::GetArgsForProcess()}) {}

## ◆ ~PlaygroundTest()

impeller::PlaygroundTest::~PlaygroundTest | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ GetBackend()

PlaygroundBackend impeller::PlaygroundTest::GetBackend | ( |  | ) | const

Definition at line 57 of file playground_test.cc.

57 {
58 return GetParam();
59 }

Referenced by GetWindowTitle().

## ◆ GetWindowTitle()

std::string impeller::PlaygroundTest::GetWindowTitle | ( |  | ) | const
| override virtual

Implements impeller::Playground.

Definition at line 82 of file playground_test.cc.

82 {
83 std::stringstream stream;
84 stream << "Impeller Playground for '"
85 << flutter::testing::GetCurrentTestName() << "' ";
86 switch (GetBackend()) {
87 case PlaygroundBackend::kMetal:
88 break;
89 case PlaygroundBackend::kOpenGLES:
90 if (switches_.use_angle) {
91 stream << " (Angle) ";
92 }
93 break;
94 case PlaygroundBackend::kVulkan:
95 if (switches_.use_swiftshader) {
96 stream << " (SwiftShader) ";
97 }
98 break;
99 }
100 stream << " (Press ESC to quit)";
101 return stream.str();
102 }

References GetBackend(), impeller::kMetal, impeller::kOpenGLES, impeller::kVulkan, impeller::Playground::switches_, impeller::PlaygroundSwitches::use_angle, and impeller::PlaygroundSwitches::use_swiftshader.

## ◆ OpenAssetAsMapping()

std::unique_ptr< fml::Mapping > impeller::PlaygroundTest::OpenAssetAsMapping | ( | std::string | asset_name | ) | const
| override virtual

Implements impeller::Playground.

Definition at line 66 of file playground_test.cc.

67 {
68 return flutter::testing::OpenFixtureAsMapping(asset_name);
69 }

## ◆ OpenAssetAsRuntimeStage()

RuntimeStage::Map impeller::PlaygroundTest::OpenAssetAsRuntimeStage | ( | const char * | asset_name | ) | const

Definition at line 71 of file playground_test.cc.

72 {
73 const std::shared_ptr<fml::Mapping> fixture =
74 flutter::testing::OpenFixtureAsMapping(asset_name);
75 if (!fixture || fixture->GetSize() == 0) {
76 return {};
77 }
78 return RuntimeStage::DecodeRuntimeStages(fixture);
79 }

References impeller::RuntimeStage::DecodeRuntimeStages().

## ◆ SetUp()

void impeller::PlaygroundTest::SetUp | ( |  | ) |
| override

Definition at line 28 of file playground_test.cc.

28 {
29 if (!Playground::SupportsBackend(GetParam())) {
30 GTEST_SKIP_("Playground doesn't support this backend type.");
31 return;
32 }
33
34 if (!Playground::ShouldOpenNewPlaygrounds()) {
35 GTEST_SKIP_("Skipping due to user action.");
36 return;
37 }
38
39 ImpellerValidationErrorsSetFatal(true);
40
41 // Test names that end with "WideGamut" will render with wide gamut support.
42 std::string test_name = flutter::testing::GetCurrentTestName();
43 PlaygroundSwitches switches = switches_;
44 switches.enable_wide_gamut =
45 test_name.find("WideGamut/") != std::string::npos;
46
47 if (switches.enable_wide_gamut && (GetParam() != PlaygroundBackend::kMetal ||
48 !DoesSupportWideGamutTests())) {
49 GTEST_SKIP_("This backend doesn't yet support wide gamut.");
50 return;
51 }
52
53 SetupContext(GetParam(), switches);
54 SetupWindow();
55 }

References impeller::PlaygroundSwitches::enable_wide_gamut, impeller::ImpellerValidationErrorsSetFatal(), impeller::kMetal, impeller::Playground::SetupContext(), impeller::Playground::SetupWindow(), impeller::Playground::ShouldOpenNewPlaygrounds(), impeller::Playground::SupportsBackend(), and impeller::Playground::switches_.

## ◆ TearDown()

void impeller::PlaygroundTest::TearDown | ( |  | ) |
| override

Definition at line 61 of file playground_test.cc.

61 {
62 TeardownWindow();
63 }

References impeller::Playground::TeardownWindow().

Referenced by impeller::AiksPlayground::TearDown().

The documentation for this class was generated from the following files:

- impeller/playground/playground_test.h
- impeller/playground/playground_test.cc

impeller::Playground::ShouldOpenNewPlaygrounds
static bool ShouldOpenNewPlaygrounds()
Definition: playground.cc:167
impeller::PlaygroundBackend::kVulkan
@ kVulkan
impeller::RuntimeStage::DecodeRuntimeStages
static Map DecodeRuntimeStages(const std::shared_ptr< fml::Mapping > &payload)
Definition: runtime_stage.cc:61
impeller::PlaygroundBackend::kMetal
@ kMetal
impeller::PlaygroundSwitches::enable_wide_gamut
bool enable_wide_gamut
Definition: switches.h:35
impeller::PlaygroundSwitches::use_swiftshader
bool use_swiftshader
Definition: switches.h:27
impeller::Playground::SetupWindow
void SetupWindow()
Definition: playground.cc:137
impeller::Playground::switches_
const PlaygroundSwitches switches_
Definition: playground.h:118
impeller::Playground::SetupContext
void SetupContext(PlaygroundBackend backend, const PlaygroundSwitches &switches)
Definition: playground.cc:124
impeller::PlaygroundSwitches::use_angle
bool use_angle
Definition: switches.h:33
impeller::ImpellerValidationErrorsSetFatal
void ImpellerValidationErrorsSetFatal(bool fatal)
Definition: validation.cc:16
impeller::PlaygroundBackend::kOpenGLES
@ kOpenGLES
impeller::Playground::SupportsBackend
static bool SupportsBackend(PlaygroundBackend backend)
Definition: playground.cc:100
impeller::Playground::TeardownWindow
void TeardownWindow()
Definition: playground.cc:156
impeller::Playground::Playground
Playground(PlaygroundSwitches switches)
Definition: playground.cc:83
impeller::PlaygroundTest::GetBackend
PlaygroundBackend GetBackend() const
Definition: playground_test.cc:57